;------------------------------------------------------------------------------
; usbconv for AT90S2313  Ver 1.0  2005.03.10 by K.Ishikawa
;------------------------------------------------------------------------------

	.include "tn2313def.inc"

;------------------------------------------------------------------------------
;	AVR Port Assign List
;
;	PortB bit0  LED
;	      bit1  Select 0:Mouse 1:Keyboard 
;	      bit2  
;	      bit3  
;	      bit4  
;	      bit5  (MOSI)
;	      bit6  (MISO)
;	      bit7  (SCK)
;	PortD bit0  RxD
;	      bit1  TxD
;	      bit2  USB BUS D+
;	      bit3  USB BUS D-
;	      bit4  
;	      bit5  
;	      bit6  

;------------------------------------------------------------------------------

	.def	reg_0		= r10
	.def	buttons		= r11
	.def	msex		= r12
	.def	msey		= r13
	.def	keynum		= r14
	.def	itrvl		= r15
	.def	uart_num	= r16
	.def	uart_cnt	= r17
	.def	uart_data	= r18
	.def	icount		= r19
	.def	connect		= r20
	.def	tcount		= r21
	.def	arg1		= r22
	.def	arg2		= r23
	.def	tmp1		= r24
	.def	tmp2		= r25

	.equ    UARTBUF		= $60	; Start UART Buffer Location
	.equ    USBBUFSTART	= $74	; Start USB Buffer Location
	.equ    INTERVAL	= 24 	; Interrupt Inverval(ms)

;------------------------------------------------------------------------------


;------------------------------------------------------------------------------

	rjmp	MAIN		; Reset Handler
	rjmp	EXT_INT0	; IRQ0 Handler
	rjmp	EXT_INT1	; IRQ0 Handler
	rjmp	TIM1_CAPT	; Timer1 Capture Handler
	rjmp	TIM1_COMP	; Timer1 Compare Handler
	rjmp	TIM1_OVF	; Timer1 Overflow Handler
	rjmp	TIM0_OVF	; Timer0 Overflow Handler
	rjmp	UART_RXC	; UART RX Complete Handler
	rjmp	UART_DRE	; UDR Empty Handler
	rjmp	UART_TXC	; UART TX Complete Handler
	rjmp	ANA_COMP	; Analog Comparator Handler

;------------------------------------------------------------------------------

EXT_INT0:
EXT_INT1:
TIM1_CAPT:
TIM1_COMP:
TIM1_OVF:
UART_RXC:
UART_DRE:
UART_TXC:
ANA_COMP:
	reti


;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

DATA_EOP:
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_ACK:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x08, 0x08, 0x04, 0x08, 0x08, 0x04, 0x04, 0x04
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_SETUP_TOKEN_0:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x08, 0x04
	.db		0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04
	.db		0x08, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04, 0x08
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_SET_ADDRESS_1:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x04, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04, 0x04
	.db		0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04
	.db		0x04, 0x08, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x08, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x08
	.db		0x08, 0x04, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_DATA_IN_0_0:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x04
	.db		0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04
	.db		0x08, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04, 0x08
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_SETUP_TOKEN_1:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x08, 0x04
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x08
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_SET_CONFIGURATION_1:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x04, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04, 0x04
	.db		0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04
	.db		0x04, 0x08, 0x04, 0x04, 0x08, 0x04, 0x08, 0x04
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x08, 0x08, 0x08, 0x04, 0x08, 0x08, 0x04, 0x08
	.db		0x08, 0x04, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_DATA_IN_1_0:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x04
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.db		0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x08
	.db		0x02, 0x02, 0x08, 0x08
DATA_PKT_DATA_IN_1_1:
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x04
	.db		0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.db		0x08, 0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x08
	.db		0x02, 0x02, 0x08, 0x08

	.org	0x100

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

MAIN:
	; **** Initialize Stack Pointer ****
	ldi		tmp1, LOW(RAMEND)	; Stack Pointer Setup
	out		SPL, tmp1			; Stack Pointer Low Byte	
	; **** Turn off Watchdog timer ****
	ldi		tmp1, 0x18			; 
	out		WDTCR, tmp1			; 
	ldi		tmp1, 0x10			; 
	out		WDTCR, tmp1			;
	; **** Initialize Comparator ****
	ldi		tmp1, 0x80			; Disable comparator to save power
	out		ACSR, tmp1			; 
	; **** Initialize I/O Port ****
	ldi		tmp1, 0x05			; Set PB2 (3do_in) as Output Mode
	out		DDRB, tmp1
	ldi		tmp1, 0x1f			; IN H
	out		PORTB, tmp1
	ldi		tmp1, 0x00			; Set PD0-6 as Input Mode
	out		DDRD, tmp1
	ldi		tmp1, 0x00			; PD2-3 HI-Z
	out		PORTD, tmp1
	; **** Initialize UART ****
	ldi		tmp1, 0
	out		UBRRH, tmp1
	ldi		tmp1, 2
	out		UBRRL, tmp1			; UART Baud rate generator
	ldi		tmp1, 0xe0
	out		UCSRA, tmp1
	ldi		tmp1, 0x0d			; UART Interrupt Disables
	out		UCSRB, tmp1			; TX Enable, 9-Bit Disable
	ldi		tmp1, 0x0e			
	out		UCSRC, tmp1
	; **** Initialize Timer 0 ****
	ldi		tcount, 0x00			; 
	ldi		tmp1, 0x02			; Enable Timer0 Overflow Interrupt
	out		TIMSK, tmp1
	ldi		tmp1, 69			; 1ms Timer Count
	out		TCNT0, tmp1
	ldi		tmp1, 0x03			; CK/64, Timer Start
	out		TCCR0, tmp1
	sei							; Enable Global Interrupt
	; **** Initialize Register ****
	ldi		tmp1, 0
	mov		reg_0, tmp1
	ldi		tmp1, 0
	mov		buttons, tmp1
	ldi		tmp1, 0
	mov		msex, tmp1
	mov		msey, tmp1
	ldi		connect, 0			; Set State Disconnect
	ldi		tcount, 0
	ldi		icount, 0
	ldi		uart_data, 0
	ldi		uart_cnt, 0
	ldi		uart_num, 0
	mov		keynum, reg_0
	clr		itrvl
	; **** Power On Wait ****
	ldi		arg1, 10			; 1sec wait
	rcall	DELAY_100MS
	ldi		tmp1, 0x1F			; LED OFF
	out		PORTB, tmp1
	
	; **** Main Loop ****
MAIN_LOOP:
	ldi		arg1, 1				; 1ms wait
	rcall	DELAY_1MS
	cpi		connect, 0			; Check State
	breq	MAIN_LOOP_DISCONNECT
	rjmp	MAIN_CONNECT
MAIN_LOOP_DISCONNECT:
	rjmp	MAIN_DISCONNECT

;------------------------------------------------------------------------------

MAIN_CONNECT:
	; **** Check Disconnection ****
	sbis	PIND, 3
	rjmp	MAIN_DISCONNECTING
	
	; **** Send EOP ****
	ldi		ZH, HIGH(DATA_EOP*2)
	ldi		ZL, LOW(DATA_EOP*2)
	ldi		arg1, 4
	rcall	USB_SND_ROM
	; **** Interval Count ****

	inc		itrvl
	ldi		arg1, INTERVAL
	cp		itrvl, arg1
	breq	MAIN_INTERRUPT_STATE

BACK_RETURN:
	cpi		icount, 0
	breq	MAIN_PREP_STATE
	cpi		icount, 1
	breq	MAIN_SEND_STATE

	sbis	PIND, 0	//state 2
	clr		icount
	rjmp	MAIN_LOOP

MAIN_SEND_STATE:		//state 1
	sbic	PIND, 0
	inc		icount
	rjmp	MAIN_SEND_PROCESS

MAIN_PREP_STATE:	//state 0
	inc		icount
	rjmp	MAIN_MOUSE_PROCESS

MAIN_INTERRUPT_STATE:
	clr		itrvl
	
	; **** Interrupt Transfer ****
	ldi		ZH, HIGH(DATA_PKT_DATA_IN_1_1*2)
	ldi		ZL, LOW(DATA_PKT_DATA_IN_1_1*2)
	ldi		arg1, 36
	rcall	USB_SND_ROM
	rcall	USB_RCV
	mov		tmp2, arg1
	ldi		ZH, HIGH(USBBUFSTART+8)	; Check DATA0/1 or NAK/STALL
	ldi		ZL, LOW(USBBUFSTART+8)
	ld		tmp1, Z
	sbrc	tmp1, 3
	rjmp	MAIN_CORRECT

	ldi		ZH, HIGH(DATA_PKT_ACK*2)
	ldi		ZL, LOW(DATA_PKT_ACK*2)
	ldi		arg1, 20
	rcall	USB_SND_ROM	

MAIN_PROCESS:
	; *** Processing Received Data ****
	mov		arg1, tmp2
	rcall	USB_CONV	

	ldi		YH, HIGH(USBBUFSTART+2)	; Y = USBBUFSTART+2
	ldi		YL, LOW(USBBUFSTART+2)

	ld		buttons, Y+
	
	ld		arg1, Y+
	asr		arg1
	asr		msex
	add		msex, arg1

	ld		arg1, Y+
	asr		arg1
	asr		msey
	add		msey, arg1

	rjmp	MAIN_LOOP



MAIN_SEND_PROCESS:


	ldi		YH, HIGH(UARTBUF)	; Y = USBBUFSTART+2
	ldi		YL, LOW(UARTBUF)
	mov		uart_data, uart_num
	dec		uart_data
	rcall	USART_TransmitPROC
	ld		uart_data, Y+
	rcall	USART_TransmitDATA
	ld		uart_data, Y+
	rcall	USART_TransmitDATA
	ld		uart_data, Y+
	rcall	USART_TransmitDATA
	ld		uart_data, Y+
	rcall	USART_TransmitDATA
	ld		uart_data, Y+
	rcall	USART_TransmitDATA

	rjmp	MAIN_LOOP

MAIN_CORRECT:

	rjmp	MAIN_LOOP

MAIN_MOUSE_PROCESS:

	ldi		ZH, HIGH(UARTBUF)	; Z = USBBUFSTART
	ldi		ZL, LOW(UARTBUF)

	ld		arg2, Z
	inc		arg2
	andi	arg2, 0x7
	st		Z, arg2

	asr		msey
	asr		msex

	lsl		msex
	lsl		msey

	clr		arg1
	mov		arg2, buttons
	bst		arg2, 0
	bld		arg1, 7
	bst		arg2, 1
	bld		arg1, 6
	bst		arg2, 2
	bld		arg1, 5
	mov		arg2, msey
	
	bst		arg2, 7	
	bld		arg1, 3
	bld		arg1, 2
	bld		arg1, 1
	bst		arg2, 6
	bld		arg1, 0

	std		Z+1, arg1
	lsl		arg2
	lsl		arg2

	mov		arg1, msex
	bst		arg1, 7
	bld		arg2, 1
	bld		arg2, 0

	std		Z+2, arg2
	std		Z+3, arg1
	
	ldi		ZH, HIGH(UARTBUF)	; Z = USBBUFSTART
	ldi		ZL, LOW(UARTBUF)
	ldi		uart_num, 5
	mov		uart_cnt, uart_num
	ldi		arg1, 4
	rcall	CRC_PROC
	st		Z, arg1

	clr		msex
	clr		msey
MAIN_MOUSE_PROCESS_END:
	rjmp	MAIN_LOOP

;------------------------------------------------------------------------------

MAIN_DISCONNECTING:
	; **** 500ms Wait ****
	
	ldi		arg1, 5				; 500ms wait
	rcall	DELAY_100MS
	
	; **** Recheck Disconnection ****
	sbis	PIND, 3
	ldi		connect, 0			; Set State Disconnect
	rjmp	MAIN_LOOP

;------------------------------------------------------------------------------

MAIN_DISCONNECT:
	; **** Check Connection ****
	sbis	PIND, 3
	rjmp	MAIN_LOOP

;------------------------------------------------------------------------------

MAIN_CONNECTING:
	; **** 500ms Wait ****
	
	ldi		arg1, 5				; 500ms wait
	rcall	DELAY_100MS
	
	; **** Recheck Connection ****
	sbis	PIND, 3
	rjmp	MAIN_LOOP
	
	
	; **** USB Reset ****
	ldi		arg1, 200			; 200ms wait
	rcall	DELAY_1MS
	ldi		tmp1, 0x0C			; Set PD2 and PD3 as output mode
	out		DDRD, tmp1
	ldi		tmp1, 0x02			; Set Bus Reset
	out		PORTD, tmp1
	ldi		arg1, 10			; 10ms wait
	rcall	DELAY_1MS
	ldi		tmp1, 0x00			; Set PD2 and PD3 as input mode
	out		DDRD, tmp1
	ldi		tmp1, 0x00			; PD2-3 HI-Z
	out		PORTD, tmp1
	
	; **** 40ms Loop ****
	ldi		tmp1, 40
MAIN_CONNECTING_AFTER_RESET:
	push	tmp1
	ldi		arg1, 1				;1ms Wait
	rcall	DELAY_1MS
	; **** Send EOP ****
	ldi		ZH, HIGH(DATA_EOP*2)
	ldi		ZL, LOW(DATA_EOP*2)
	ldi		arg1, 4
	rcall	USB_SND_ROM
	pop		tmp1
	dec		tmp1
	brne	MAIN_CONNECTING_AFTER_RESET
	
	; **** Set Address ****
	ldi		ZH, HIGH(DATA_PKT_SETUP_TOKEN_0*2)
	ldi		ZL, LOW(DATA_PKT_SETUP_TOKEN_0*2)
	ldi		arg1, 36
	rcall	USB_SND_ROM
	ldi		ZH, HIGH(DATA_PKT_SET_ADDRESS_1*2)
	ldi		ZL, LOW(DATA_PKT_SET_ADDRESS_1*2)
	ldi		arg1, 100
	rcall	USB_SND_ROM
	rcall	USB_RCV
MAIN_CONNECTING_SET_ADDRESS:
	ldi		ZH, HIGH(DATA_PKT_DATA_IN_0_0*2)
	ldi		ZL, LOW(DATA_PKT_DATA_IN_0_0*2)
	ldi		arg1, 36
	rcall	USB_SND_ROM
	rcall	USB_RCV
	ldi		ZH, HIGH(USBBUFSTART+8)	; Check DATA0/1 or NAK/STALL
	ldi		ZL, LOW(USBBUFSTART+8)
	ld		tmp1, Z
	sbrc	tmp1, 3
	rjmp	MAIN_CONNECTING_SET_ADDRESS
	ldi		ZH, HIGH(DATA_PKT_ACK*2)
	ldi		ZL, LOW(DATA_PKT_ACK*2)
	ldi		arg1, 20
	rcall	USB_SND_ROM

	; **** Send EOP ****
	ldi		arg1, 1
	rcall	DELAY_1MS
	ldi		ZH, HIGH(DATA_EOP*2)
	ldi		ZL, LOW(DATA_EOP*2)
	ldi		arg1, 4
	rcall	USB_SND_ROM

	; **** Set Configuration ****
	ldi		ZH, HIGH(DATA_PKT_SETUP_TOKEN_1*2)
	ldi		ZL, LOW(DATA_PKT_SETUP_TOKEN_1*2)
	ldi		arg1, 36
	rcall	USB_SND_ROM
	ldi		ZH, HIGH(DATA_PKT_SET_CONFIGURATION_1*2)
	ldi		ZL, LOW(DATA_PKT_SET_CONFIGURATION_1*2)
	ldi		arg1, 100
	rcall	USB_SND_ROM
	rcall	USB_RCV
MAIN_CONNECTING_SET_CONFIG:
	ldi		ZH, HIGH(DATA_PKT_DATA_IN_1_0*2)
	ldi		ZL, LOW(DATA_PKT_DATA_IN_1_0*2)
	ldi		arg1, 36
	rcall	USB_SND_ROM
	rcall	USB_RCV
	ldi		ZH, HIGH(USBBUFSTART+8)	; Check DATA0/1 or NAK/STALL
	ldi		ZL, LOW(USBBUFSTART+8)
	ld		tmp1, Z
	sbrc	tmp1, 3
	rjmp	MAIN_CONNECTING_SET_CONFIG
	ldi		ZH, HIGH(DATA_PKT_ACK*2)
	ldi		ZL, LOW(DATA_PKT_ACK*2)
	ldi		arg1, 20
	rcall	USB_SND_ROM
	
	; **** Finish Connecting ****
	
	ldi		connect, 1			; Set State Connect

	rjmp	MAIN_LOOP

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

; parameter	ZH:ZL ... send data address
;           arg1  ... send data length
; return	none
; crash		arg1, tmp1, ZH, ZL, r0

USB_SND_ROM:
	ldi		tmp1, 0x08			; 
	out		PORTD, tmp1
	ldi		tmp1, 0x0C			; Set PD2 and PD3 as output mode
	out		DDRD, tmp1
USB_SND_ROM_LOOP:
	lpm							; r0 = (Z)
	inc		ZL
	out		PORTD, r0
	dec		arg1
	brne	USB_SND_ROM_LOOP
USB_SND_ROM_LOOPEND:
	ldi		tmp1, 0x00			; Set PD2 and PD3 as input mode
	out		DDRD, tmp1
	out		PORTD, tmp1			; Set PD2 and PD3 as HI-Z
	ret

;------------------------------------------------------------------------------

; parameter	none
; return    arg1  ... received data length
; crash		arg1, tmp1, ZH, ZL

USB_RCV:
	ldi		ZH, HIGH(USBBUFSTART)	; Z = USBBUFSTART
	ldi		ZL, LOW(USBBUFSTART)
	ldi		tmp1, 96
USB_RCV_WAITLOOP:
	sbic	PIND, 3				; Wait until PD3(D-) == 0
	rjmp	USB_RCV_WAITLOOP
USB_RCV_RCVLOOP:
	in		arg1, PIND
	st		Z+, arg1
	andi	arg1, 0x0C
	breq	USB_RCV_ENDLOOP
	dec		tmp1
	brne	USB_RCV_RCVLOOP
USB_RCV_ENDLOOP:
	sbis	PIND, 3				; Wait until PD3(D-) == 1
	rjmp	USB_RCV_ENDLOOP
	ldi		arg1, 100
	sub		arg1, tmp1	
	ret

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

; parameter	arg1  ... convert data length
; return	none
; crash		arg1, tmp1, tmp2. ZH, ZL

USB_CONV:
	rcall	USB_CONV_NRZI
	rcall	USB_CONV_BYTE
	ret

;------------------------------------------------------------------------------

; parameter	arg1  ... convert data length
; return	none
; crash		arg1, tmp1, tmp2, ZH, ZL

USB_CONV_NRZI:
	ldi		ZH, HIGH(USBBUFSTART)	; Z = USBBUFSTART
	ldi		ZL, LOW(USBBUFSTART)
	ldi		tmp1, 0x0B
USB_CONV_NRZI_LOOP:
	ld		tmp2, Z
	cp		tmp1, tmp2
	brne	USB_CONV_NRZI_NE
USB_CONV_NRZI_EQ:
	ldi		tmp2, 1
	rjmp	USB_CONV_NRZI_LOOPEND
USB_CONV_NRZI_NE:
	mov		tmp1, tmp2
	ldi		tmp2, 0
USB_CONV_NRZI_LOOPEND:
	st		Z+, tmp2
	dec		arg1
	brne	USB_CONV_NRZI_LOOP
	ldi		tmp1, 0xFF			; Set End Mark
	st		Z, tmp1
	ret

;------------------------------------------------------------------------------

; parameter	none
; return	none
; crash		arg1, arg2, tmp1, tmp2, YH, YL, ZH, ZL

USB_CONV_BYTE:
	ldi		YH, HIGH(USBBUFSTART)	; Y = USBBUFSTART
	ldi		YL, LOW(USBBUFSTART)
	ldi		ZH, HIGH(USBBUFSTART)	; Z = USBBUFSTART
	ldi		ZL, LOW(USBBUFSTART)
	ldi		tmp1, 0				; clear bit stuff count
USB_CONV_BYTE_LOOP1:
	ldi		tmp2, 0				; clear data
	ldi		arg1, 8
USB_CONV_BYTE_LOOP2:
	ld		arg2, Y+
	cpi		arg2, 0xFF
	breq	USB_CONV_BYTE_END
	ror		arg2
	ror		tmp2
	sbrs	tmp2, 7
	rjmp	USB_CONV_BYTE_0
USB_CONV_BYTE_1:
	inc		tmp1
	cpi		tmp1, 6
	brne	USB_CONV_BYTE_LOOPEND
	adiw	YL, 1
USB_CONV_BYTE_0:
	ldi		tmp1, 0
USB_CONV_BYTE_LOOPEND:
	dec		arg1
	brne	USB_CONV_BYTE_LOOP2
	st		Z+, tmp2
	rjmp	USB_CONV_BYTE_LOOP1
USB_CONV_BYTE_END:
	st		Z, arg2
	ret

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
	
TIM0_OVF:
	in		keynum, SREG
	inc		tcount
	push	tmp1
	ldi		tmp1, 69			; 1ms Timer Count
	out		TCNT0, tmp1
	pop		tmp1
	out		SREG, keynum
	reti

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

; parameter	arg1 ... delay time (ms)
; return	none
; crash		arg1, tmp1

DELAY_1MS:
	mov		tmp1, tcount
DELAY_1MS_LOOP:
	cp		tmp1, tcount
	breq	DELAY_1MS_LOOP
	dec		arg1
	brne	DELAY_1MS
	ret

;------------------------------------------------------------------------------

; parameter	arg1 ... delay time (100ms)
; return	none
; crash		arg1, tmp1, tmp2

DELAY_100MS:
	push	arg1
	ldi		arg1, 100
	rcall	DELAY_1MS
	pop		arg1
	dec		arg1
	brne	DELAY_100MS
	ret


;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

USART_TransmitDATA:
; Wait for empty transmit buffer
	sbis	UCSRA,UDRE
	rjmp	USART_TransmitDATA
;	ret
; Copy 9th bit from r17 to TXB8
	sbi		UCSRB,TXB8
; Put LSB data (r16) into buffer, sends the data
	out		UDR,uart_data
	ret

USART_TransmitPROC:
; Wait for empty transmit buffer
	sbis	UCSRA,UDRE
	rjmp	USART_TransmitPROC
;	ret
; Copy 9th bit from r17 to TXB8
	cbi		UCSRB,TXB8
; Put LSB data (r16) into buffer, sends the data
	out		UDR,uart_data
	ret


CRC_PROC:
	mov		tmp1, arg1
CRC_LOOP:
	ld		tmp2, Z+
	eor		tmp1, tmp2
	bst		tmp1, 7
	lsl		tmp1
	bld		tmp1, 0
	dec		arg1
	brne	CRC_LOOP
	mov		arg1, tmp1
	ret
